Attribute VB_Name = "basTimeSync"

' Modul        : basTimeSync
' Beschreibung : Modul zur Ermittlung des aktuellen Datums und der aktuellen Zeit
'                ber einen NTP-Zeit-Server aus dem Internet.
'                Als Besonderheit wird dabei auf das Winsock-OCX siDelayichtet und
'                direkt auf die entsprechenden API-Funktionen zugegriffen.
'
' Erstellt von : Ingmar Runge
' Erstellt am  : Sonntag, 24.8.2003
' Gendert am  : Freitag, 19.9.2003
'
' Copyright (C) 2003 bei Ingmar Runge, alle Rechte vorbehalten.
' Kontakt: mastermind@ircastle.de



Option Explicit

Private Const NTP_PORT As Integer = 37 ' TCP-Port fr den "Network Time Protocol"-Dienst

' Deklarationen fr das Sockets-Handling und die Verbindung:
Private Const WS_VERSION_REQD As Integer = &H101
Private Const AF_INET As Integer = 2
Private Const PF_INET As Integer = 2
Private Const SOCK_STREAM As Integer = 1
Private Const IPPROTO_TCP As Integer = 6
Private Const WINSOCKMSG As Integer = 1025
Private Const FD_READ As Integer = &H1&
Private Const FD_CONNECT As Integer = &H10&
Private Const HOSTENT_SIZE As Integer = 16
Private Const SOCKADDR_SIZE As Integer = 16
Private Const SOL_SOCKET As Long = &HFFFF&
Private Const SO_LINGER As Integer = &H80&
Private Const INADDR_NONE As Integer = -1
Private Const INVALID_SOCKET As Integer = -1
Private Const SOCKET_ERROR As Integer = -1

Private Type WSAData ' Infos ber die Winsock-Version
    wVersion As Integer
    wHighVersion As Integer
    szDescription As String * 257
    szSystemStatus As String * 129
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpVendorInfo As Long
End Type

Private Type HostEnt ' Infos ber einen Host
    heName As Long
    heAliases As Long
    heAddrType As Integer
    heLength As Integer
    heAddrList As Long
End Type

Private Type SockAddr ' Infos zum Erstellen einer Verbindung
    saFamily As Integer
    saPort As Integer
    saAddr As Long
    saZero As String * 8
End Type

Private Type LingerType ' Optionen, die festlegen, ob und wann die
                        ' Verbindung automatisch getrennt wird.
    soOnOff As Integer
    soLinger As Integer
End Type

Private Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSAData) As Long
Private Declare Function WSAGetLastError Lib "wsock32.dll" () As Long
Private Declare Function WSAIsBlocking Lib "wsock32.dll" () As Long
Private Declare Function WSACleanup Lib "wsock32.dll" () As Long
Private Declare Function WSACancelBlockingCall Lib "wsock32.dll" () As Long
Private Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal s As Long, ByVal hWnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long
Private Declare Function Socket Lib "wsock32.dll" Alias "socket" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long
Private Declare Function Connect Lib "wsock32.dll" Alias "connect" (ByVal s As Long, ByRef name As SockAddr, ByVal namelen As Long) As Long
Private Declare Function Send Lib "wsock32.dll" Alias "send" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Private Declare Function Receive Lib "wsock32.dll" Alias "recv" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Private Declare Function CloseSocket Lib "wsock32.dll" Alias "closesocket" (ByVal s As Long) As Long
Private Declare Function GetHostByName Lib "wsock32.dll" Alias "gethostbyname" (ByVal host_name As String) As Long
Private Declare Function InetAddr Lib "wsock32.dll" Alias "inet_addr" (ByVal cp As String) As Long
Private Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
Private Declare Function SetSockOpt Lib "wsock32.dll" Alias "setsockopt" (ByVal s As Long, ByVal Level As Long, ByVal optname As Long, optval As Any, ByVal optlen As Long) As Long
Private Declare Function GetSockOpt Lib "wsock32.dll" Alias "getsockopt" (ByVal s As Long, ByVal Level As Long, ByVal optname As Long, optval As Any, optlen As Long) As Long

' Deklarationen zur Erstellung eines Dummy-Controls frs Subclassing:
Private Const WS_OVERLAPPEDWINDOW As Long = 13565952
Private Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hWnd As Long) As Long

' Subclassing-Deklarationen:
Private Const GWL_WNDPROC = (-4)
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

' Deklaratonen zum Setzen der Systemzeit:
Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type
Private Declare Function SetSystemTime Lib "kernel32.dll" (lpSystemTime As SYSTEMTIME) As Long

' Allgemeine Deklarationen:
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)
' FormatMessage ermittelt eine Fehlerbeschreibung anhand einer Fehlernummer!
Private Declare Function FormatMessage Lib "kernel32.dll" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
Private Const LANG_NEUTRAL As Integer = &H0 ' = System-Sprache
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000

' Variablen:
Private SocketInfo As WSAData ' Winsock-Versions-Infos
Private lSock As Long ' Socket-Handle

Private sTimeServer As String ' Zeitserver (Hostname)
Private sReturnedData As String ' Antwort vom Server
Private siDelay As Single ' Verzgerung zwischen Verbindungsaufbau und Datenempfang

Private hWndDummy As Long ' Window-Handle des Dummy-Fensters fr Subclassing
Private lPrevWndProc As Long ' vorheriger Message-Handler des Dummy-Fensters
Private bExecuting As Boolean ' luft die Ermittlung noch?
Private bShowErrors As Boolean ' Fehlermeldungen zeigen?

' Haupt-Funktion:
Public Function GetDateTime(ByVal TimeServer As String, _
        Optional ByVal SetAsSystemTime As Boolean = False, _
        Optional ByVal ShowErrorMessages As Boolean = True) As Date
    
    Dim Delta As Single, DateUTC As Date, SysTime As SYSTEMTIME
    
    If bExecuting Then ' Die Funktion wurde bereits aufgerufen und der
                       ' Vorgang ist noch nicht abgeschlossen
        If ShowErrorMessages Then MsgBox "Die Funktion wird bereits ausgefhrt!", vbCritical
        Exit Function
    End If
    
    ' Variablen zurcksetzen
    sReturnedData = ""
    siDelay = 0
    lSock = 0
    bShowErrors = ShowErrorMessages
    bExecuting = True
    sTimeServer = TimeServer

    
    ' Als nchstes wird ein unsichtbares Fenster erstellt, das wir brauchen, um
    ' Nachrichten des Winsock-Controls (welches wird im folgenden erstellen) abzufangen.
    
    ' Dummy Fenster erstellen...
    hWndDummy = CreateWindowEx(0, "static", "dummy", WS_OVERLAPPEDWINDOW, -10, -10, 10, 10, 0, 0, App.hInstance, ByVal 0&)
    ' ...und subclassen (Messages an das Fenster abfangen):
    lPrevWndProc = SetWindowLong(hWndDummy, GWL_WNDPROC, AddressOf SubWndProc)
    
    ' Winsock initialisieren
    If WSAStartup(WS_VERSION_REQD, SocketInfo) <> 0 Then
        ' In SocketInfo stehen Infos zur Winsock-Version
        ShowErrorMessage "Winsock (""" & _
            IIf(InStr(1, SocketInfo.szDescription, Chr(0)) > 0, _
            Left(SocketInfo.szDescription, InStr(1, SocketInfo.szDescription, Chr(0))), _
            SocketInfo.szDescription) & """) konnte nicht geladen werden!"
        GoTo ClearUp
    End If
    
    If EstablishConnection Then ' Verbindung aufbauen
        
        Delta = Timer + 10 ' Timeout-Zeit 10 Sekunden
        Do ' Auf Antwort vom Server warten
            DoEvents
            Sleep 1 ' **ghn**  (Prozessor entlasten)
            DoEvents
            sReturnedData = Trim(sReturnedData)
        Loop Until ((sReturnedData <> Empty) Or (Timer > Delta))
                    ' Daten angekommen oder Timeout
        
        CloseConnection ' Verbindung schlieen
        
        If sReturnedData <> Empty Then ' Ist was angekommen?
        
            siDelay = ((Timer - siDelay) / 2) ' Verzgerungszeit berechnen
            DateUTC = CalculateTime() ' Zeit aus Daten vom Server errechnen
            
            If SetAsSystemTime Then ' Als Systemzeit einstellen ?
                With SysTime
                    .wDay = Day(DateUTC)
                    .wHour = Hour(DateUTC)
                    .wMinute = Minute(DateUTC)
                    .wMonth = Month(DateUTC)
                    .wSecond = Second(DateUTC)
                    .wYear = Year(DateUTC)
                End With
                SetSystemTime SysTime ' System-Zeit einstellen
            End If
            
        Else
            MsgBox "Keine Daten vom Server empfangen!", vbCritical
        End If
    End If
    
ClearUp:
    ' Subclassing aufheben...
    SetWindowLong hWndDummy, GWL_WNDPROC, lPrevWndProc
    lPrevWndProc = 0
    ' ...und Dummy-Fenster lschen
    DestroyWindow hWndDummy
    
    ' Puuhh... geschafft!
    GetDateTime = DateUTC
    bExecuting = False
End Function

' Zeit aus den vom Server empfangenen Daten errechnen:
Private Function CalculateTime() As Date
Dim SersiDelayeit As Double, DateUTC As Date, d90 As Date

If Len(sReturnedData) <> 4 Then
    ShowErrorMessage "Keinen gltigen Wert vom Server empfangen!"
    Exit Function
End If

' String mit 4 Zeichen in Double-Wert umwandeln:
SersiDelayeit = Asc(Left(sReturnedData, 1)) * 256# ^ 3 + _
    Asc(Mid(sReturnedData, 2, 1)) * 256# ^ 2 + _
    Asc(Mid(sReturnedData, 3, 1)) * 256# + _
    Asc(Right(sReturnedData, 1))

' Datumskorrektur... Sekunden seit 1.1.1990:
SersiDelayeit = SersiDelayeit - 2840140800#

' Sekunden auf den 1.1.1990 addieren:
d90 = CDate("1.1.1990 00:00:00")
DateUTC = DateAdd("s", CDbl(SersiDelayeit + CLng(siDelay)), d90)

CalculateTime = DateUTC
End Function

' Verbindung zum Zeitserver aufbauen:
Private Function EstablishConnection() As Boolean
    Dim SockSets As SockAddr, l As Long
    Dim Linger As LingerType
    
    EstablishConnection = True
    
    With SockSets ' Optionen fr den Verbindungsaufbau
        .saFamily = AF_INET ' Internet
        .saPort = htons(NTP_PORT) ' Port
        If .saPort = INVALID_SOCKET Then
            ShowErrorMessage "Ermitteln der internen Port-Nummer fehlgeschlagen!"
            EstablishConnection = False
            Exit Function
        End If
        .saAddr = GetHostLong(sTimeServer) ' interne Host-Adresse
        
        If .saAddr = INADDR_NONE Then
            ' Ermitteln der internen Host-Adress-Nummer fehlgeschlagen
            EstablishConnection = False
            Exit Function
        End If
        
    End With
    
    ' neuen Socket erstellen:
    lSock = Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP) ' Internet-TCP-Verbindung
    If lSock < 0 Then
        ShowErrorMessage "Erstellen eines neuen Sockets fehlgeschlagen!"
        EstablishConnection = False
        Exit Function
    End If
    
    
    ' Linger legt fest, ob die Verbindung nach einer bestimmten Zeit getrennt
    ' werden soll, auch wenn die Datenbertragung noch nicht abgeschlossen ist.
    ' http://msdn.microsoft.com/library/en-us/winsock/winsock/setsockopt_2.asp
    
    With Linger
        Linger.soOnOff = 1 ' an/aus
        Linger.soLinger = 0 ' Zeit in ms
    End With
    
    ' wenn soOnOff <> 0 und soLinger = 0 dann ist die Funktion komplett deaktiviert,
    ' die Verbindung wird also erst getrennt, wenn das Programm das veranlasst.
    
    ' Setzen der Linger-Optionen:
    If SetSockOpt(lSock, SOL_SOCKET, SO_LINGER, Linger, Len(Linger)) <> 0 Then
        If lSock > 0 Then Call CloseSocket(lSock)
        ShowErrorMessage "Fehler beim Setzen der Linger-Optionen!"
        EstablishConnection = False
        Exit Function
    Else ' berprfen der gesetzten Linger-Optionen:
        If GetSockOpt(lSock, SOL_SOCKET, SO_LINGER, Linger, 4) <> 0 Then
            If lSock > 0 Then Call CloseSocket(lSock)
            ShowErrorMessage "Fehler beim Ermitteln/berprfen der Linger-Optionen!"
            EstablishConnection = False
            Exit Function
        End If
    End If
    
    ' Jetzt muss dem Socket gesagt werden, dass wir mit Standard-Windows-Nachrichten
    ' an unser Dummy-Control benachrichtuigt werden wollen. Und zwar mit der Message
    ' WINSOCKMSG und den Notifications FD_READ und FD_CONNECT
    ' (siehe Kommentar zu SubWndProc)
    l = FD_READ Or FD_CONNECT
    If WSAAsyncSelect(lSock, hWndDummy, ByVal WINSOCKMSG, ByVal l) Then
        If lSock > 0 Then Call CloseSocket(lSock)
        ShowErrorMessage "Umleiten der Ereignisse des Sockets fehlgeschlagen!"
        EstablishConnection = False
        Exit Function
    End If
    
    ' Jetzt knnen wir endlich die Verbindung mit den in SockSets festgelegten
    ' Optionen aufbauen!
    If Connect(lSock, SockSets, SOCKADDR_SIZE) <> -1 Then
        If lSock > 0 Then Call CloseSocket(lSock)
        ShowErrorMessage "Aufbauen der Verbindung fehlgeschlagen!"
        EstablishConnection = False
        Exit Function
    End If
    
End Function

' Die Verbindung beenden und unseren Socket entladen:
Private Sub CloseConnection()
    CloseSocket lSock
    If WSAIsBlocking <> 0 Then WSACancelBlockingCall
    WSACleanup
End Sub

' Subclassing-Callback-Funktion:
Public Function SubWndProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If Msg = WINSOCKMSG Then ' Winsock-Nachricht
        IncomingMessage wParam, lParam
    Else ' andere Nachricht
        SubWndProc = CallWindowProc(lPrevWndProc, hWnd, Msg, wParam, lParam)
    End If
End Function

' Hier werden die Winsock-Messages an unser Dummy-Control ausgewertet:
Private Sub IncomingMessage(ByVal lSourceSocket As Long, ByVal lParam As Long)

    Dim x As Long, Buffer(1 To 1024) As Byte, s As String
    
    DoEvents
    
    Select Case lParam
        Case FD_CONNECT ' Die Verbindung wurde hergestellt
            siDelay = Timer

        Case FD_READ ' es sind Daten angekommen, die aus dem
                     ' Empfangs-Puffer ausgelesen werden mssen.
            Do
                x = Receive(lSourceSocket, Buffer(1), 1024, 0) ' Auslesen in 1 KB-Blcken
                If x > 0 Then
                    s = s & Left(StrConv(CStr(Buffer), vbUnicode), x) ' Byte-Array in String umwandeln
                End If
                If x <> 1024 Then Exit Do ' Der Puffer ist nicht mehr voll,
                                          ' also sind alle Daten angekommen
            Loop
            
            sReturnedData = s
            s = ""
            Erase Buffer
            
    End Select
    
End Sub


' ######### Es folgen Hilfsfunktionen ################################################

Private Function GetHostLong(ByVal sHost As String) As Long
' Gibt fr einen Hostname einen Long-Wert zurck, mit
' dem Winsock intern arbeitet.
    Dim lInetAddr As Long
    Dim lHbn As Long
    Dim tHost As HostEnt
    Dim AddressList As Long
    Dim lIP As Long
    
    lInetAddr = InetAddr(sHost) ' interne Adresse ermitteln
    lIP = lInetAddr
    If lInetAddr = INADDR_NONE Then ' falls InetAddr fehlgeschlagen ist
        lHbn = GetHostByName(sHost) ' Host-Infos ermitteln
        If lHbn <> 0 Then
            ' Daten aus Long-Variable "lHbn" in "tHost" vom Typ "HostEnt" kopieren:
            CopyMemory tHost, ByVal lHbn, HOSTENT_SIZE ' Gre
            CopyMemory AddressList, ByVal tHost.heAddrList, 4 ' IP-Adress-Liste
            CopyMemory lIP, ByVal AddressList, tHost.heLength ' erste Adresse der Liste
        Else
            ShowErrorMessage "GetHostByName lieferte ungltiges Ergebnis!"
            GetHostLong = INADDR_NONE
            Exit Function
        End If
    End If
    
    GetHostLong = lIP
End Function

Private Function GetErrorMessage(ByVal ErrNr As Long) As String
' Ermittelt die System-Fehlermeldung anhand einer Fehlernummer

Dim sBuf As String
sBuf = Space(255) ' Puffer erstellen

' Aufruf von FormatMessage:
FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, 0&, ErrNr, _
    LANG_NEUTRAL, sBuf, Len(sBuf), ByVal 0&

' Null-Zeichen abschneiden:
GetErrorMessage = Left(sBuf, InStr(1, sBuf, vbNullChar))
End Function

Private Sub ShowErrorMessage(Optional ByVal UserDefindedMsg As String = "")
' Zeigt eine Fehlermeldung mit einem benutzerdefinierten Text
' und der System-Fehler-Meldung (falls vorhanden) an.
Dim Msg As String

If bShowErrors Then
    Msg = GetErrorMessage(Err.LastDllError)
    
    ' GetErrorMessage(0) = "Der Vorgang wurde erfolgreich ausgefhrt." oder so
    If Msg = GetErrorMessage(0) Then Msg = ""
    If UserDefindedMsg <> Empty Then _
        Msg = "FEHLER: " & UserDefindedMsg & vbCrLf & Msg
    
    MsgBox Msg, vbCritical
End If

End Sub

